SystemOrganization addCategory: #'TADP-Meta1'!
SystemOrganization addCategory: #'TADP-Meta1- Fixture'!
SystemOrganization addCategory: #'TADP-Meta1- Fixture2'!
SystemOrganization addCategory: #'TADP-Metaprogramacion'!
SystemOrganization addCategory: #'TADP-Metaprogramacion-Fixture'!
SystemOrganization addCategory: #'TADP-Metaprogramacion-Fixture-Tests'!
SystemOrganization addCategory: #'TADP-TestMeta1'!
SystemOrganization addCategory: #'TADP-Meta1- Test'!

TestCase subclass: #ExtractSuperclassTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Metaprogramacion'!

!ExtractSuperclassTestCase methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:38'!
setUp
	MetaUtil recreateCategory: 'TADP-Metaprogramacion-Fixture'.! !

!ExtractSuperclassTestCase methodsFor: 'as yet unclassified' stamp: 'guiw5 5/9/2013 16:08'!
testExtraerAnimalDePerro
	| animalClass perroClass|
	
	perroClass := Smalltalk at: #Perro.

	SimpleExtractSuperclass from: perroClass to: #Animal.
	
	animalClass := Smalltalk at: #Animal.
	
	self assert: (animalClass instVarNames includes: 'hambre').
	
	self assert: 'comer: unNro
	self hambre: self hambre - unNro
	'
		equals: (animalClass >> #comer:) sourceCode 
	.
	
	self assert: animalClass equals: (perroClass superclass).
	self assert: perroClass selectors isEmpty.
	self assert: perroClass instVarNames isEmpty.! !

TestCase subclass: #TestsTheInterceptor
	instanceVariableNames: 'perrito gatito'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1- Test'!

!TestsTheInterceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/10/2013 21:03'!
setUp 
"	MetaUtil recreateCategory: 'TADP-Meta1- Fixture'."
"	MetaUtil recreateCategory: 'TADP-Meta1'."
	TheInterceptor categoryClasses: Set new.			
	TheInterceptor estrategia: [:selector | selector beginsWith: 'c'].! !

!TestsTheInterceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:37'!
testAgregarCodigoAntesYdespuesDeCiertosMetodos
	
	DonPerro  selectors do: [:unSelector|  DonPerro removeSelector: unSelector . DonGato removeSelector: unSelector ].
	Perrin selectors do: [: unSel | DonGato compile: (Perrin >> unSel ) getSource. DonPerro compile: (Perrin >> unSel ) getSource.].
	
	TheInterceptor interceptame: 'TADP-Meta1- Fixture2' poniendoAntes: 'consumirEnergia: unParam
	self energia: self energia - unParam.
	^ self energia.'  yDespues: 'verificarSaldo: unNro
	(unNro < 0 )ifTrue: [^0. ] ifFalse: [^unNro. ] '.

	self assert: ( DonPerro selectors includes: #metodoInterceptoralias1cargarSaldo: ).
"equals: [ 'metodoInterceptoralias1cargarSaldo:unaEnergia
self verificarEnergia:(self alias1cargarSaldo: (self consumirEnergia:unaEnergia))']."
	perrito := DonPerro new.
	perrito energia: 10.
	perrito hambre: 11.

	perrito metodoInterceptoralias1correr: 20. self assert:  (perrito hambre) equals: 1.	
	perrito metodoInterceptoralias1comer: -11. self assert: (perrito hambre ) equals: 0.

	self assert: (DonPerro >> #metodoInterceptoralias1cargarSaldo:) getSource 
	equals: 'metodoInterceptoralias1cargarSaldo: unParam
 	 self verificarSaldo: (self alias1cargarSaldo: (self consumirEnergia: unParam)).'.! !

!TestsTheInterceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:24'!
testCrearAliasAunMetodoDeUnaClase
	
	TheInterceptor crearAliasAl: #correr: de: Gato.
	
	self assert: (Gato selectors includes:  #alias1correr:).
! !

!TestsTheInterceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:42'!
testDecorarMetodoDeUnaClaseConUnoAntesYotroDespues
	TheInterceptor decorarMetodo: #comer: de: Gatin con: 'metodoAnt: algo
^6.' y: 'metodoPost: algo
^algo.'.
	
	self assert: (Gatin selectors anySatisfy: [:unSel | unSel beginsWith: 'alias']).
	self assert: (Gatin selectors includes: #metodoInterceptoralias1comer: ).! !

!TestsTheInterceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 01:00'!
testMetodosAinterceptarDeUnaClase
	"los metodos a interceptar son los que empiezan con c (dada una estrategia)"
	self assert: (TheInterceptor metodosAinterceptarDe: Perro) equals:  #(#cargarSaldo: #comer: #correr:).! !

!TestsTheInterceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 01:16'!
testSeAgregaElMetodoAntYelPost
	TheInterceptor interceptar: Gatin con: 'metodoAnt: algo
^6.' y: 'metodoPost: algo
^algo.'.

self assert: (Gatin selectors includes: #metodoAnt:) .
self assert: (Gatin selectors includes: #metodoPost:) .! !

Object subclass: #DonGato
	instanceVariableNames: 'hambre energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1- Fixture2'!

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
alias4correLolaCorre: unParam 
^unParam .! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
andar
	self hambre: self hambre + 1.! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
cargarSaldo: unParam 
	^unParam .! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
comer: unParam  
	^(self hambre: self hambre - unParam ).! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
correr: unParam  
	^ self hambre: self hambre + unParam .! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
energia
	^ energia.! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
energia: unParam 
	energia := unParam  .! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
estaEnojado
	^ self hambre > 20! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
hambre
	^ hambre! !

!DonGato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
hambre: unParam 
	hambre := unParam .! !

Object subclass: #DonPerro
	instanceVariableNames: 'hambre energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1- Fixture2'!

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
alias4correLolaCorre: unParam 
^unParam .! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
andar
	self hambre: self hambre + 1.! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
cargarSaldo: unParam 
	^unParam .! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
comer: unParam  
	^(self hambre: self hambre - unParam ).! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
correr: unParam  
	^ self hambre: self hambre + unParam .! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
energia
	^ energia.! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
energia: unParam 
	energia := unParam  .! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
estaEnojado
	^ self hambre > 20! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
hambre
	^ hambre! !

!DonPerro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:42'!
hambre: unParam 
	hambre := unParam .! !

Object subclass: #Gatin
	instanceVariableNames: 'energia hambre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1- Fixture'!

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:27'!
alias4correLolaCorre: unParam 
^unParam .! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/10/2013 20:40'!
andar
	self hambre: self hambre + 1.! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:27'!
cargarSaldo: unParam 
	^unParam .! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:27'!
comer: unParam  
	^(self hambre: self hambre - unParam ).! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:27'!
correr: unParam  
	^ self hambre: self hambre + unParam .! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/10/2013 20:40'!
energia
	^ energia.! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:27'!
energia: unParam 
	energia := unParam  .! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/10/2013 20:40'!
estaEnojado
	^ self hambre > 20! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/10/2013 20:40'!
hambre
	^ hambre! !

!Gatin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:27'!
hambre: unParam 
	hambre := unParam .! !

Object subclass: #Gato
	instanceVariableNames: 'hambre energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Metaprogramacion-Fixture'!

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
alias4correLolaCorre: unParam 
^unParam .! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
andar
	self hambre: self hambre + 1.! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
cargarSaldo: unParam 
	^unParam .! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
comer: unParam  
	^(self hambre: self hambre - unParam ).! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
correr: unParam  
	^ self hambre: self hambre + unParam .! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
energia
	^ energia.! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
energia: unParam 
	energia := unParam  .! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
estaEnojado
	^ self hambre > 20! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
hambre
	^ hambre! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
hambre: unParam 
	hambre := unParam .! !

!Gato methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
verificarSaldo: unParam 
^unParam .! !

Object subclass: #Perrin
	instanceVariableNames: 'energia hambre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1- Fixture'!

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
alias4correLolaCorre: unParam 
^unParam .! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
andar
	self hambre: self hambre + 1.! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
cargarSaldo: unParam 
	^unParam .! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
comer: unParam  
	^(self hambre: self hambre - unParam ).! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
correr: unParam  
	^ self hambre: self hambre + unParam .! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
energia
	^ energia.! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
energia: unParam 
	energia := unParam  .! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
estaEnojado
	^ self hambre > 20! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
hambre
	^ hambre! !

!Perrin methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
hambre: unParam 
	hambre := unParam .! !

Object subclass: #Perro
	instanceVariableNames: 'hambre energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Metaprogramacion-Fixture'!

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
alias4correLolaCorre: unParam 
^unParam .! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
andar
	self hambre: self hambre + 1.! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
cargarSaldo: unParam 
	^unParam .! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
comer: unParam  
	^(self hambre: self hambre - unParam ).! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
correr: unParam  
	^ self hambre: self hambre + unParam .! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
energia
	^ energia.! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
energia: unParam 
	energia := unParam  .! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
estaEnojado
	^ self hambre > 20! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
hambre
	^ hambre! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
hambre: unParam 
	hambre := unParam .! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:12'!
verificarSaldito: unNro
	(unNro < 0 )ifTrue: [^0. ] ifFalse: [ (unNro = 0 ) ifTrue: [^nil. ] ifFalse: [^unNro.]] ! !

!Perro methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:31'!
verificarSaldo: unParam 
^unParam .! !

Object subclass: #SimpleExtractSuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Metaprogramacion'!

!SimpleExtractSuperclass class methodsFor: 'as yet unclassified' stamp: 'Demian 4/28/2013 12:29'!
from: target to: superclassName

	| newSuperclass |
	newSuperclass  := target superclass
		subclass: superclassName 
		 instanceVariableNames:  ''
		classVariableNames:  ''
		poolDictionaries:  (target poolDictionaryNames joinUsing: ' ')
		category:  target category.
	

	target instVarNames do: [ :attributeName | newSuperclass addInstVarNamed:  attributeName ].
	
	target selectors do: [ :selector | 
		newSuperclass compile: (target >> selector) sourceCode. 
		target removeSelector: selector. 
	].

	target superclass: newSuperclass.

	target instVarNames do: [ :attributeName | target removeInstVarNamed: attributeName ].	
! !

Object subclass: #TheInterceptor
	instanceVariableNames: 'categoryClasses estrategia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

TheInterceptor class
	instanceVariableNames: 'categoryClasses estrategia statements alias'!

TheInterceptor class
	instanceVariableNames: 'categoryClasses estrategia statements alias'!

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/8/2013 16:15'!
alias 
	^alias .! !

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/8/2013 16:15'!
alias: unAlias
	alias:= unAlias.! !

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/4/2013 02:17'!
categoryClasses
	^categoryClasses.! !

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/4/2013 02:17'!
categoryClasses: unasClases 
	categoryClasses:=unasClases .! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:19'!
crearAliasAl: metodoAinterceptar de: unaClase
	| nrosAliasosos newMetodo codigoDelPosta losStatements |
	
	nrosAliasosos := (#(1 2 3 4 5 6 7 8 9 )
							select: [ :unNumero | self yaExisteAliasPara: metodoAinterceptar de: unaClase con: unNumero ]).

	self alias: ('alias', (nrosAliasosos first) asString, metodoAinterceptar asString) asSymbol.

	codigoDelPosta := (unaClase >> metodoAinterceptar) getSource.
	
	losStatements := codigoDelPosta copyFrom: (codigoDelPosta lineNumber: 1) size to: codigoDelPosta size.
	
	unaClase compile: (self alias asString, ' unParam' , '<n> <t>' expandMacros, losStatements).! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 02:24'!
decorarMetodo: metodoAinterceptar de: unaClase con: metodoAnt y: metodoPost
	|  argumentos miParser metodoNuevo |
		
	self crearAliasAl: metodoAinterceptar de: unaClase.

	miParser := Parser new.	

	argumentos := miParser parseParameterNames: metodoAnt .
								
	unaClase compile: ('metodoInterceptor', self alias, ' ',(argumentos first)  asString , '<n> <t>' expandMacros, ' self ', (miParser parseSelector: metodoPost) asString ,
					 ' (self ',  self alias asString , ' (self ', (miParser parseSelector: metodoAnt) asString , ' ', (argumentos first) asString, ')).').

	unaClase compile: metodoAnt .

	unaClase compile: metodoPost .	! !

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/4/2013 02:17'!
estrategia
	^estrategia.! !

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/4/2013 02:17'!
estrategia: unBloque 
	estrategia:= unBloque.! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:14'!
interceptame: unaCategoria poniendoAntes:unMetodo yDespues: otroMetodo

	(self obtenerCategoryClassesDe: unaCategoria) 
			do: [: unaClase | self interceptar: unaClase con: unMetodo y: otroMetodo].! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/9/2013 01:24'!
interceptar: unaClase con: unMetodo y: otroMetodo

	(self metodosAinterceptarDe: unaClase)
		do: [ :metodoAinterceptar | 
			self decorarMetodo: metodoAinterceptar de: unaClase con: unMetodo y: otroMetodo.].! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:13'!
metodosAinterceptarDe: unaClase

	^ ((unaClase selectors) select: self estrategia).! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:12'!
obtenerCategoryClassesDe: unaCategoria

	self categoryClasses: ((SystemOrganization listAtCategoryNamed: unaCategoria) 
							collect: [:each | Smalltalk globals at: each]).

	^ self categoryClasses.! !

!TheInterceptor class methodsFor: 'extra' stamp: 'guiw5 5/8/2013 22:51'!
parsearMetodo: unMetodo

	| miParser hastaFinDelMetodo desdeFinDeSelector retornoDeUnMetodo |

	miParser := Parser new.

	self selector: (miParser parseSelector: unMetodo).
	self argumentos: (miParser parseParameterNames: unMetodo).

	desdeFinDeSelector := (unMetodo lineNumber:1) size + 1.
	hastaFinDelMetodo := unMetodo size.
	statements := unMetodo copyFrom: desdeFinDeSelector to: hastaFinDelMetodo.
	
	((statements findString: '^') > 0 ) ifTrue: [retornoDeUnMetodo := (statements copyFrom: (statements findString: '^') + 1 to: statements size).]  ifFalse: [retornoDeUnMetodo := 0 ].
	
	^ retornoDeUnMetodo.! !

!TheInterceptor class methodsFor: 'extra' stamp: 'guiw5 5/9/2013 01:22'!
pasarMetodosDe: unaClase a: unTrait
 		
	(self metodosAinterceptarDe: unaClase)
		do: [:unSelector | unTrait compile: (unaClase >> unSelector ) sourceCode.
				unaClase removeSelector: unSelector.].! !

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/4/2013 20:50'!
statements 
	^statements.! !

!TheInterceptor class methodsFor: 'accessing' stamp: 'guiw5 5/4/2013 20:51'!
statements: unCodigo 
	
	statements := unCodigo.! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/11/2013 00:05'!
yaExisteAliasPara: metodoAinterceptar de: unaClase con: unNumero

		^(unaClase methodDictionary includesKey: ('alias' , unNumero asString , metodoAinterceptar asString) asSymbol) ifTrue: [^ false] ifFalse: [^true].! !
